#! /usr/bin/env python

## Solaris's cp executable doesn't offer an update option, so we'll
## simulate one.

import os, sys, shutil
from stat import ST_MTIME

scriptName = os.path.basename(sys.argv[0])

sourceFile = sys.argv[1]
destinationArg = sys.argv[2]

if ( not os.path.isfile(sourceFile) ):
    raise IOError("Source file %s does not exist." % (sourceFile))

if os.path.isdir(destinationArg):
    destinationFile = os.path.join(destinationArg, os.path.basename(sourceFile))
else:
    destinationFile = destinationArg

if ( os.path.exists(destinationFile) ):
    sourceTime = os.stat(sourceFile)[ST_MTIME]
    destinationTime = os.stat(destinationFile)[ST_MTIME]
    copyNeeded = sourceTime > destinationTime
else:
    copyNeeded = True

if copyNeeded:
    print("%s: Copying %s -> %s" % (scriptName, sourceFile, destinationFile))
    ## copy2 preserves the source's mod time
    shutil.copy2(sourceFile, destinationFile)
else:
    print("%s: %s is up to date." % (scriptName, destinationFile))
