#! /usr/bin/env python

import re, os, sys
try:
    set
except NameError:
    from sets import Set as set

#from sets import Set
from distutils.text_file import TextFile

inputFile = TextFile(sys.argv[1], join_lines=1)

######################################################################
## Examine the first line to determine the target.

firstLine = inputFile.readline()
inputFile.unreadline(firstLine)

targetMatch = re.match('(\S+)(\.o):', firstLine)
targetPrefix = targetMatch.group(1)
targetSuffix = targetMatch.group(2)
targetObj = targetPrefix + targetSuffix

#######################################################################
## figure out the new target name
def addSuffix(suffix):
    return targetPrefix + suffix;

newTarget = " ".join(map(addSuffix, (targetSuffix, ".d")))


########################################################################
## Start the set of prerequisites with ones the compiler doesn't know
## about.

prereqs = set(["Makefile",
               "$(TPRO_ROOT)/buildUtils/fixDependencies.py",
               "$(TPRO_ROOT)/buildUtils/dependencyGeneration.mk"])

common_mk = "../common.mk"
if (os.path.isfile(common_mk)):
        prereqs.add(common_mk)

###################################################################
## Process all of the input lines and add the prereqs to the set.  We
## use a set because the compiler doesn't weed out duplicates.

allLines = inputFile.readlines()
lineHasTarget = re.compile('\S+\.o: ')
whitespace = re.compile('\s+')
for line in allLines:
    linePrereqsString = re.sub(lineHasTarget, '', line)
    linePrereqs = whitespace.split(linePrereqsString)
    prereqs |= set(linePrereqs)

####################################################################
## Iterate over the found prerequisites, generating one line each.
for prereq in prereqs:
        print( "%s: %s" % (newTarget, prereq))

               
