#include "tsync_hw_nonkts_func.h"
#include "ddtsync.h"

#ifdef LAFAYETTE
#include "tsync_hw_nonkts_lafayette.h"
#endif

TSYNC_ERROR hw_nonkts_get_trans(uint16_t iid,
                                TPRO_INSTANCE_T *hw,
                                uint8_t *inPayload,
                                uint32_t inLength,
                                uint8_t *outPayload,
                                uint32_t maxOutLength,
                                uint32_t *actualOutLength) {

    TSYNC_ERROR result = TSYNC_DRV_INVALID_INDEX;

    switch(iid) {

#ifdef LAFAYETTE
#include "tsync_hw_nonkts_func_p1.lafayette"
#endif

        default:
            result = TSYNC_DRV_INVALID_INDEX;
            *actualOutLength = 0;
            break;
    };

    return result;

} /* end of hw_nonkts_get_trans */


TSYNC_ERROR hw_nonkts_set_trans(uint16_t iid,
                                TPRO_INSTANCE_T *hw,
                                uint8_t *inPayload,
                                uint32_t inLength,
                                uint8_t *outPayload,
                                uint32_t maxOutLength,
                                uint32_t *actualOutLength) {

    TSYNC_ERROR result = TSYNC_DRV_INVALID_INDEX;

    switch(iid) {

#ifdef LAFAYETTE
#include "tsync_hw_nonkts_func_p2.lafayette"
#endif

        default:
            result = TSYNC_DRV_INVALID_INDEX;
            break;

    };

    *actualOutLength = 0;

    return result;

} /* end of hw_nonkts_set_trans */
