#ifndef __tpro_macros_h__
#define __tpro_macros_h__ 1


#include <stdio.h>
#define errorLog(...) fprintf(stderr, __VA_ARGS__)

#define CHECK(CALLEE,EXPECTED)                                          \
{                                                                       \
    unsigned char actualReturned = (CALLEE);                            \
    if (actualReturned != (EXPECTED)) {                                 \
                                                                        \
        errorLog("%s returned %u, expected %u. (%s:%u)\n", #CALLEE,     \
                 actualReturned, EXPECTED, __FILE__,__LINE__);          \
        return actualReturned;                                          \
    }                                                                   \
}

#define CHECK_HANDLE(handle) if ((handle) == NULL) { return TPRO_HANDLE_ERR; }
#define CHECK_NOT_NULL(pointer) if ((pointer) == NULL) { return TPRO_NULL_POINTER; }

#endif
