
  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  tpro_boolean_t bIsTsync;
  CHECK(TPRO_boardIsTsync(hnd, &bIsTsync),
        TPRO_SUCCESS);
  
  if(bIsTsync == TPRO_TRUE)
  {
    unsigned short id;
    unsigned short rev;
    unsigned char  digit;
    int            i;
    
    TSYNC_ERROR err = TSYNC_HW_getFpgaInfo((TSYNC_BoardHandle) hnd, &id, &rev);
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }
    
    memset(fpga, '\0', 5);
    for (i = 0; i < 4; i++)
    {
        digit       = (rev >> (i * 4)) && 0xF;
        fpga[3 - i] = (digit > 9) ? (digit - 0x0A + 0x41) : (digit + 0x30);
    }
                
    return (TPRO_SUCCESS);
  }
