
  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  tpro_boolean_t bIsTsync;
  CHECK(TPRO_boardIsTsync(hnd, &bIsTsync),
        TPRO_SUCCESS);
  
  if(bIsTsync == TPRO_TRUE)
  {
    TSYNC_FixDataObj pObj;
    TSYNC_ERROR err = TSYNC_GR_getFixData((TSYNC_BoardHandle) hnd,
                                          TSYNC_DEFAULT_GPS_INSTANCE,
                                          &pObj);
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }
    
    Satp->satsTracked = pObj.nSats;
    Satp->satsView = Satp->satsTracked;

    return (TPRO_SUCCESS);
  }
