
  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  tpro_boolean_t bIsTsync;
  CHECK(TPRO_boardIsTsync(hnd, &bIsTsync),
        TPRO_SUCCESS);
  
  if(bIsTsync == TPRO_TRUE)
  {
    TSYNC_GPOSquareObj pObj;
    pObj.off = 0;
    if (Heartp->frequency < 1)
    {
    pObj.per = (0x80000000);
    pObj.per += (unsigned int)(1000000.000001 / Heartp->frequency);
    }
    else
    {
        pObj.per = (unsigned int)(1000000000 / Heartp->frequency);
    }
    pObj.pw  = 1000000;
    pObj.ae  = EDGE_RISING;
    
    TSYNC_ERROR err = TSYNC_SUCCESS;
    
    err = (err == TSYNC_SUCCESS) ?
          TSYNC_GO_setMode((TSYNC_BoardHandle) hnd, OD_PIN_0,
                           OD_MODE_SQUARE_WAVE) : err;
    err = (err == TSYNC_SUCCESS) ?
          TSYNC_GO_setSquareWave((TSYNC_BoardHandle) hnd, OD_PIN_0, &pObj) : err;
    err = (err == TSYNC_SUCCESS) ?
          TSYNC_GO_setEnable((TSYNC_BoardHandle) hnd, OD_PIN_0, 1) : err;
    
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }
    
    return (TPRO_SUCCESS);
  }
