
  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  tpro_boolean_t bIsTsync;
  CHECK(TPRO_boardIsTsync(hnd, &bIsTsync),
        TPRO_SUCCESS);

  if(bIsTsync == TPRO_TRUE)
  {
    if (MICROSECONDS_NAME == NULL)
    {
        return (TPRO_SUCCESS);
    }

    TSYNC_ERROR err = TSYNC_SUCCESS;
    TSYNC_BoardHandle handle = (TSYNC_BoardHandle) hnd;
    unsigned int nInstances = 0;
    unsigned int nNanos = *MICROSECONDS_NAME * 1000;

    {
        err = TSYNC_PR_getNumInst(handle, &nInstances);
        if (err != TSYNC_SUCCESS)
        {
            printf(" *** Error: %s.\n", tsync_strerror(err));
            return TPRO_COMM_ERR;
        }

        unsigned int i;
        for(i = 0; i < nInstances; i ++)
        {
            err = TSYNC_PR_setOffset(handle, i, nNanos);
            if (err != TSYNC_SUCCESS)
            {
                printf(" *** Error: %s.\n", tsync_strerror(err));
                return TPRO_COMM_ERR;
            }
        }
    }

    err = TSYNC_GR_setOffset(handle,
                             TSYNC_DEFAULT_GPS_INSTANCE,
                             *MICROSECONDS_NAME);
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }

    {
        err = TSYNC_IR_getNumInst(handle, &nInstances);
        if (err != TSYNC_SUCCESS)
        {
            printf(" *** Error: %s.\n", tsync_strerror(err));
            return TPRO_COMM_ERR;
        }

        unsigned int i;
        for(i = 0; i < nInstances; i ++)
        {
            err = TSYNC_IR_setOffset(handle, i, nNanos);
            if (err != TSYNC_SUCCESS)
            {
                printf(" *** Error: %s.\n", tsync_strerror(err));
                return TPRO_COMM_ERR;
            }
        }
    }

    {
        err = TSYNC_IP_getNumInst(handle, &nInstances);
        if (err != TSYNC_SUCCESS)
        {
            printf(" *** Error: %s.\n", tsync_strerror(err));
            return TPRO_COMM_ERR;
        }

        unsigned int i;
        for(i = 0; i < nInstances; i ++)
        {
            err = TSYNC_IP_setOffset(handle, (IO_PORT)i, nNanos);
            if (err != TSYNC_SUCCESS)
            {
                printf(" *** Error: %s.\n", tsync_strerror(err));
                return TPRO_COMM_ERR;
            }
        }
    }

    {
        err = TSYNC_PP_getNumInst(handle, &nInstances);
        if (err != TSYNC_SUCCESS)
        {
            printf(" *** Error: %s.\n", tsync_strerror(err));
            return TPRO_COMM_ERR;
        }

        unsigned int i;
        for(i = 0; i < nInstances; i ++)
        {
            err = TSYNC_PP_setOffset(handle, i, nNanos);
            if (err != TSYNC_SUCCESS)
            {
                printf(" *** Error: %s.\n", tsync_strerror(err));
                return TPRO_COMM_ERR;
            }
        }
    }

    return (TPRO_SUCCESS);
  }
