
  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  tpro_boolean_t bIsTsync;
  CHECK(TPRO_boardIsTsync(hnd, &bIsTsync),
        TPRO_SUCCESS);

  if(bIsTsync == TPRO_TRUE)
  {
    // enable the interrupt
    TSYNC_ERROR err = TSYNC_HW_setIntMask(
        (TSYNC_BoardHandle) hnd,
        INT_GPIO_OUT,
        1,
        0);
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }

    err = TSYNC_waitFor((TSYNC_BoardHandle) hnd, INT_GPIO_OUT, 1);
    if (err != TSYNC_SUCCESS)
    {
        printf(" *** Error: %s.\n", tsync_strerror(err));
        return TPRO_COMM_ERR;
    }

    return (TPRO_SUCCESS);
  }
