#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"

/*==========================================================================
  TPRO_getSatInfo
==========================================================================*/

unsigned char TPRO_getSatInfo (TPRO_BoardObj *hnd, TPRO_SatObj *Satp)
{
  int err;

  SatObj SatelliteInfo;

  tpro_boolean_t boardSupportsGPS;

  // make sure we have valid handle
  CHECK_HANDLE(hnd);
  CHECK_NOT_NULL(Satp);

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #include "tpro_legacy_getsatinfo.h"
  
  
  CHECK(TPRO_boardSupportsGPSHardware(hnd, &boardSupportsGPS), TPRO_SUCCESS);
  if (boardSupportsGPS != TPRO_TRUE) {
      return (TPRO_INVALID_BOARD_TYPE_ERR);
  }
  
  /**
  ***  create I/O control returns nonzero on success
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_GET_SAT_INFO, &SatelliteInfo);
  if (err < 0)	return (TPRO_COMM_ERR);

  /**
  ***  fill-in users context
  **/

  Satp->satsTracked = SatelliteInfo.satsTracked;

  return (TPRO_SUCCESS);
}
