#include <sys/ioctl.h>
#include <stdio.h>
#include <math.h>

#include <ddtpro.h>
#include <tpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tpro_date_time.h"
#include "tsync.h"

/*==========================================================================
  TPRO_setMatchTime
==========================================================================*/

unsigned char TPRO_setMatchTime (TPRO_BoardObj *hnd, TPRO_MatchObj *Matchp)
{
  int err;

  MatchObj Matchtime;


  // make sure we have valid handle
  CHECK_HANDLE(hnd);
  CHECK_NOT_NULL(Matchp);

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #include "tpro_legacy_setmatchtime.h"
  
  /**
  ***  verify valid time
  **/
  CHECK(tpro_validateMatchTime(Matchp), TPRO_SUCCESS);

  /**
  ***  fill-in working context
  **/
  Matchtime.matchType = Matchp->matchType;
  Matchtime.days      = Matchp->days;
  Matchtime.hours     = Matchp->hours;
  Matchtime.minutes   = Matchp->minutes;
  
  Matchtime.seconds = (unsigned int) rint(Matchp->seconds * 1000000.0);

  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_SET_MATCHTIME, &Matchtime);
  err = (err < 0) ? TPRO_COMM_ERR : TPRO_SUCCESS;

  return (err);
}
