#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"



/*==========================================================================
  TPRO_setOscillator
==========================================================================*/

unsigned char TPRO_setOscillator    (TPRO_BoardObj *hnd, unsigned char *freq)
{
  int err;


  // make sure we have valid handle
  if (hnd == NULL)
     {
     return (TPRO_HANDLE_ERR);
     }
     

  /**
  ***  verify valid frequency value
  **/
    
  if ( *freq > OSC_OUT_10MHZ ) return (TPRO_FREQ_ERR);
    

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

 #include "tpro_legacy_setoscillator.h"


    
  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_SET_OSCILLATOR, &freq);
  err = (err < 0) ? TPRO_COMM_ERR : TPRO_SUCCESS;

  return (err);

}
