#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>
#include <string.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"

/*==========================================================================
  TPRO_synchControl
==========================================================================*/

unsigned char TPRO_synchControl (TPRO_BoardObj *hnd, unsigned char *enbp)
{
  int err;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #define ENABLED_NAME enbp
  #include "tpro_legacy_synchcontrol.h"
  #undef ENABLED_NAME
  
  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_SYNCH_CONTROL, enbp);
  err = (err < 0) ? TPRO_COMM_ERR : TPRO_SUCCESS;

  return (err);
}
