#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tpro_date_time.h"
#include "tsync.h"

/*==========================================================================
  TPRO_synchStatus
==========================================================================*/

unsigned char TPRO_synchStatus (TPRO_BoardObj *hnd, unsigned char *status)
{
  int err;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #define STATUS_NAME status
  #include "tpro_legacy_synchstatus.h"
  #undef STATUS_NAME

  /**
  ***  create I/O control returns nonzero on success
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_SYNCH_STATUS, status);
  err = (err < 0) ? TPRO_COMM_ERR : TPRO_SUCCESS;

  return (err);
}
