#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"

/*==========================================================================
  TPRO_waitMatch
==========================================================================*/

unsigned char TPRO_waitEvent(TPRO_BoardObj *hnd, TPRO_WaitObj *waitp)
{
  WaitObj tproWait = {0};
  int ioctl_result;
  unsigned char result;


  CHECK_HANDLE(hnd);
  CHECK_NOT_NULL(waitp);

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #include "tpro_legacy_waitevent.h"
  
  /**
  ***  capture timeout value
  **/

  tproWait.jiffies = waitp->jiffies;


  /**
  ***  create I/O control
  **/

  ioctl_result = ioctl(hnd->file_descriptor, IOCTL_TPRO_WAIT_EVENT, &tproWait);
  if (ioctl_result == 0) {
      result = TPRO_SUCCESS;
  }
  else if (ioctl_result < 0) {
      result = TPRO_COMM_ERR;
  }
  else {
      result = TPRO_TIMEOUT_ERR;
  }

  /**
  ***  copy into users context
  **/
  {
    double temp = (double) tproWait.seconds;
    temp /= (double) 1000000.0;
    waitp->seconds = temp;

    waitp->days = tproWait.days;
    waitp->hours = tproWait.hours;
    waitp->minutes = tproWait.minutes;
  }  

  return (result);
}


