#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"

/*==========================================================================
  TPRO_waitHeartbeat
==========================================================================*/

unsigned char TPRO_waitHeartbeat(TPRO_BoardObj *hnd, int *ticks)
{
  int err;


  // make sure we have valid handle
  if (hnd == NULL) {
    return (TPRO_HANDLE_ERR);
  }

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/
  
  #include "tpro_legacy_waitheartbeat.h"

  /**
  ***  create I/O control
  **/

  err = ioctl(hnd->file_descriptor, IOCTL_TPRO_WAIT_HEART, ticks);
  if (err < 0) err = TPRO_COMM_ERR;
  if (err > 0) err = TPRO_TIMEOUT_ERR;

  return (err);
}


