#include <sys/ioctl.h>
#include <stdio.h>
#include <tpro.h>
#include <ddtpro.h>

#include "tpro_macros.h"
#include "tpro_capabilities.h"
#include "tsync.h"

/*==========================================================================
  TPRO_waitMatch
==========================================================================*/

unsigned char TPRO_waitMatch(TPRO_BoardObj *hnd, int *ticks)
{
    int ioctl_result;
    unsigned char result;


  CHECK_HANDLE(hnd);
  CHECK_NOT_NULL(ticks);

  /**
  ***  determine the board type and emulate legacy
  ***  call if needed
  **/

  #include "tpro_legacy_waitmatch.h"
  
  /**
  ***  create I/O control
  **/

  ioctl_result = ioctl(hnd->file_descriptor, IOCTL_TPRO_WAIT_MATCH, ticks);
  if (ioctl_result == 0) {
      result = TPRO_SUCCESS;
  }
  else if (ioctl_result < 0) {
      result = TPRO_COMM_ERR;
  }
  else {
      result = TPRO_TIMEOUT_ERR;
  }

  return (result);
}


