#include "example.h"

int main (int argc, char *argv[])
{
    char           deviceName[32];
    int            retVal;
    TPRO_BoardObj *pBoard;
    unsigned char  rv;
    char           fpgaver[10];
    char           firmwarever[10];

    retVal = 0;
    
    /* If invalid number of events... */
    if (argc != 2) 
    {
        printf(" Usage: GetFpgaVer <device index>\n");
        return (1);
    }
    
    /* Construct the TPRO/TSAT device name */
    sprintf(deviceName, "%s%s%d", DEVICE_ROOT, DEFAULT_DEV, atoi(argv[1]));
    
    /* Open the TPRO/TSAT device */
    rv = TPRO_open(&pBoard, deviceName);
    
    /* If unable to open the TPRO/TSAT device... */
    if (rv != TPRO_SUCCESS) 
    {
        printf (" Could Not Open '%s'!! [%d]\n", deviceName, rv);
        return (1);
    }

    rv = TPRO_getFPGA(pBoard, fpgaver); 
    if ( rv != TPRO_SUCCESS) {
        printf("Could not retrieve FPGA version, error: %s\n", tpro_strerror(rv));
        retVal = 1;
    }
    else
    {
        printf (" FPGA version %s\n", fpgaver);
    }

    rv = TPRO_getFirmware(pBoard, firmwarever);
    if ( rv != TPRO_SUCCESS) {
        printf("Could not retrieve firmware version, error: %s\n", tpro_strerror(rv));
        retVal = 1;
    }
    else
    {
        printf (" firmware version %s\n", firmwarever);
    }


    /* Close the TPRO/TSAT device */
    rv = TPRO_close (pBoard);
    
    /* If unable to close the TPRO/TSAT device... */
    if (rv != TPRO_SUCCESS) 
    {
        printf("Could Not Close Board!! [%d]\n", rv);
        retVal = 1;
    }

    return (retVal);

} /* End - main() */
