#include "example.h"

int main (int argc, char *argv[])
{
    char           deviceName[32];
    TPRO_BoardObj *pBoard;
    int            retVal;
    unsigned char  status = 0;
    unsigned char  rv;

    retVal = 0;
    
    /* If invalid number of arguments... */
    if (argc != 2) 
    {
        printf(" Usage: SynchStatus <device index>\n");
        return (1);
    }

    /* Construct TPRO/TSAT device name */
    sprintf(deviceName, "%s%s%d", DEVICE_ROOT, DEFAULT_DEV, atoi(argv[1]));
    
    /* Open the TPRO/TSAT device */
    rv = TPRO_open(&pBoard, deviceName);
    
    if (rv != TPRO_SUCCESS) 
    {
        printf(" Could Not Open Board '%s'!! [%d]\n", deviceName, rv);
        return (1);
    }

    /* Get TPRO/TSAT synchronization status */
    rv = TPRO_synchStatus(pBoard, &status);
    
    /* If unable to get the TPRO/TSAT sync status... */
    if (rv != TPRO_SUCCESS) 
    {
        printf(" Could Not Get Synchronization Status!! [%d]\n", rv);
        retVal = 1;
    }
    else if (status) 
    {
        printf(" Synchronized to input!!\n");
    }
    else 
    {
        printf(" Freewheeling!!\n");
    }

    /* Close the TPRO/TSAT device */
    rv = TPRO_close(pBoard);
    
    /* If unable to close the TPRO/TSAT device... */
    if (rv != TPRO_SUCCESS) 
    {
        printf(" Could Not Close Board!! [%d]\n", rv);
        retVal = 1;
    }

    return (retVal);

} /* End - main() */
